Compare commits

..

1 Commits

Author SHA1 Message Date
Real-MullaC
bbaa44d221
Merge 81ba99beec into 8ea3da9843 2024-11-07 18:39:06 +00:00
76 changed files with 167 additions and 1067 deletions

View File

@ -1,3 +1,2 @@
external-sources=true external-sources=true
source=core/tabs/common-script.sh source=core/tabs/common-script.sh
source=core/tabs/common-service-script.sh

77
Cargo.lock generated
View File

@ -242,15 +242,6 @@ dependencies = [
"winapi", "winapi",
] ]
[[package]]
name = "deranged"
version = "0.3.11"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "b42b6fa04a440b495c8b04d0e71b707c585f83cb9cb28cf8cd0d976c315e31b4"
dependencies = [
"powerfmt",
]
[[package]] [[package]]
name = "downcast-rs" name = "downcast-rs"
version = "1.2.1" version = "1.2.1"
@ -259,9 +250,9 @@ checksum = "75b325c5dbd37f80359721ad39aca5a29fb04c89279657cffdda8736d0c0b9d2"
[[package]] [[package]]
name = "ego-tree" name = "ego-tree"
version = "0.9.0" version = "0.6.3"
source = "registry+https://github.com/rust-lang/crates.io-index" source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "7c6ba7d4eec39eaa9ab24d44a0e73a7949a1095a8b3f3abb11eddf27dbb56a53" checksum = "12a0bb14ac04a9fcf170d0bbbef949b44cc492f4452bd20c095636956f653642"
[[package]] [[package]]
name = "either" name = "either"
@ -421,9 +412,9 @@ checksum = "bbd2bcb4c963f2ddae06a2efc7e9f3591312473c50c6685e1f298068316e66fe"
[[package]] [[package]]
name = "libc" name = "libc"
version = "0.2.161" version = "0.2.158"
source = "registry+https://github.com/rust-lang/crates.io-index" source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "8e9489c2807c139ffd9c1794f4af0ebe86a828db53ecdc7fea2111d0fed085d1" checksum = "d8adc4bb1803a324070e64a98ae98f38934d91957a99cfb3a43dcbc01bc56439"
[[package]] [[package]]
name = "linutil_core" name = "linutil_core"
@ -444,6 +435,7 @@ dependencies = [
"ansi-to-tui", "ansi-to-tui",
"anstyle", "anstyle",
"clap", "clap",
"ego-tree",
"linutil_core", "linutil_core",
"oneshot", "oneshot",
"portable-pty", "portable-pty",
@ -451,7 +443,6 @@ dependencies = [
"ratatui", "ratatui",
"temp-dir", "temp-dir",
"textwrap", "textwrap",
"time",
"tree-sitter-bash", "tree-sitter-bash",
"tree-sitter-highlight", "tree-sitter-highlight",
"tui-term", "tui-term",
@ -548,21 +539,6 @@ dependencies = [
"minimal-lexical", "minimal-lexical",
] ]
[[package]]
name = "num-conv"
version = "0.1.0"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "51d515d32fb182ee37cda2ccdcb92950d6a3c2893aa280e540671c2cd0f3b1d9"
[[package]]
name = "num_threads"
version = "0.1.7"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "5c7398b9c8b70908f6371f47ed36737907c87c52af34c268fed0bf0ceb92ead9"
dependencies = [
"libc",
]
[[package]] [[package]]
name = "once_cell" name = "once_cell"
version = "1.19.0" version = "1.19.0"
@ -631,12 +607,6 @@ dependencies = [
"winreg", "winreg",
] ]
[[package]]
name = "powerfmt"
version = "0.2.0"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "439ee305def115ba05938db6eb1644ff94165c5ab5e9420d1c1bcedbba909391"
[[package]] [[package]]
name = "ppv-lite86" name = "ppv-lite86"
version = "0.2.20" version = "0.2.20"
@ -755,9 +725,9 @@ checksum = "7a66a03ae7c801facd77a29370b4faec201768915ac14a721ba36f20bc9c209b"
[[package]] [[package]]
name = "rustix" name = "rustix"
version = "0.38.38" version = "0.38.37"
source = "registry+https://github.com/rust-lang/crates.io-index" source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "aa260229e6538e52293eeb577aabd09945a09d6d9cc0fc550ed7529056c2e32a" checksum = "8acb788b847c24f28525660c4d7758620a7210875711f79e7f663cc152726811"
dependencies = [ dependencies = [
"bitflags 2.6.0", "bitflags 2.6.0",
"errno", "errno",
@ -1022,39 +992,6 @@ dependencies = [
"syn", "syn",
] ]
[[package]]
name = "time"
version = "0.3.36"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "5dfd88e563464686c916c7e46e623e520ddc6d79fa6641390f2e3fa86e83e885"
dependencies = [
"deranged",
"itoa",
"libc",
"num-conv",
"num_threads",
"powerfmt",
"serde",
"time-core",
"time-macros",
]
[[package]]
name = "time-core"
version = "0.1.2"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "ef927ca75afb808a4d64dd374f00a2adf8d0fcff8e7b184af886c3c87ec4a3f3"
[[package]]
name = "time-macros"
version = "0.2.18"
source = "registry+https://github.com/rust-lang/crates.io-index"
checksum = "3f252a68540fde3a3877aeea552b832b40ab9a69e318efd078774a01ddee1ccf"
dependencies = [
"num-conv",
"time-core",
]
[[package]] [[package]]
name = "toml" name = "toml"
version = "0.8.19" version = "0.8.19"

View File

@ -3,6 +3,9 @@ license = "MIT"
version = "24.9.28" version = "24.9.28"
edition = "2021" edition = "2021"
[workspace.dependencies]
ego-tree = "0.6.2"
[workspace] [workspace]
members = ["tui", "core", "xtask"] members = ["tui", "core", "xtask"]
default-members = ["tui", "core"] default-members = ["tui", "core"]

View File

@ -24,26 +24,6 @@ curl -fsSL https://christitus.com/linux | sh
```bash ```bash
curl -fsSL https://christitus.com/linuxdev | sh curl -fsSL https://christitus.com/linuxdev | sh
``` ```
<details>
<summary>CLI arguments</summary>
Linutil supports various command-line arguments to customize its behavior. Here are some common arguments you can use:
- `-t, --theme <THEME>` : Set the theme to use in the application [default: default] [possible values: default, compatible].
- `--override-validation` : Show all available options, disregarding compatibility checks (UNSAFE).
- `-h, --help` : Print help.
For more detailed usage, run:
```bash
curl -fsSL https://christitus.com/linux | sh -s -- --help
```
```bash
linutil --help
```
</details>
## ⬇️ Installation ## ⬇️ Installation
Linutil is also available as a package in various repositories: Linutil is also available as a package in various repositories:
@ -78,15 +58,7 @@ paru -S linutil
Replace `paru` with your preferred helper and `linutil` with your preferred package. Replace `paru` with your preferred helper and `linutil` with your preferred package.
</details> </details>
<details>
<summary>OpenSUSE</summary>
Linutil can be installed on OpenSUSE with:
```bash
sudo zypper install linutil
```
</details>
<details> <details>
<summary>Cargo</summary> <summary>Cargo</summary>
@ -100,28 +72,6 @@ Note that crates installed using `cargo install` require manual updating with `c
</details> </details>
## Configuration
Linutil supports configuration through a TOML config file. Path to the file can be specified with `--config` (or `-c`).
Available options:
- `auto_execute` - a list of commands to execute automatically (can be combined with `--skip-confirmation`)
Example config:
```toml
# example_config.toml
auto_execute = [
"Fastfetch",
"Alacritty",
"Kitty"
]
```
```bash
linutil --config /path/to/example_config.toml
```
## 💖 Support ## 💖 Support
If you find Linutil helpful, please consider giving it a ⭐️ to show your support! If you find Linutil helpful, please consider giving it a ⭐️ to show your support!

View File

@ -5,7 +5,11 @@ repository = "https://github.com/ChrisTitusTech/linutil/tree/main/core"
edition = "2021" edition = "2021"
version.workspace = true version.workspace = true
license.workspace = true license.workspace = true
include = ["src/*.rs", "Cargo.toml", "tabs/**"] include = [
"src/*.rs",
"Cargo.toml",
"tabs/**",
]
[dependencies] [dependencies]
include_dir = "0.7.4" include_dir = "0.7.4"
@ -13,4 +17,4 @@ temp-dir = "0.1.14"
serde = { version = "1.0.205", features = ["derive"], default-features = false } serde = { version = "1.0.205", features = ["derive"], default-features = false }
toml = { version = "0.8.19", features = ["parse"], default-features = false } toml = { version = "0.8.19", features = ["parse"], default-features = false }
which = "6.0.3" which = "6.0.3"
ego-tree = "0.9.0" ego-tree = { workspace = true }

View File

@ -1,28 +0,0 @@
use serde::Deserialize;
use std::path::Path;
use std::process;
#[derive(Deserialize)]
pub struct Config {
pub auto_execute: Vec<String>,
}
impl Config {
pub fn from_file(path: &Path) -> Self {
let content = match std::fs::read_to_string(path) {
Ok(content) => content,
Err(e) => {
eprintln!("Failed to read config file {}: {}", path.display(), e);
process::exit(1);
}
};
match toml::from_str(&content) {
Ok(config) => config,
Err(e) => {
eprintln!("Failed to parse config file: {}", e);
process::exit(1);
}
}
}
}

View File

@ -1,13 +1,10 @@
mod config;
mod inner; mod inner;
use std::rc::Rc; use std::rc::Rc;
pub use ego_tree;
use ego_tree::Tree; use ego_tree::Tree;
use std::path::PathBuf; use std::path::PathBuf;
pub use config::Config;
pub use inner::{get_tabs, TabList}; pub use inner::{get_tabs, TabList};
#[derive(Clone, Hash, Eq, PartialEq)] #[derive(Clone, Hash, Eq, PartialEq)]
@ -36,16 +33,3 @@ pub struct ListNode {
pub task_list: String, pub task_list: String,
pub multi_select: bool, pub multi_select: bool,
} }
impl Tab {
pub fn find_command(&self, name: &str) -> Option<Rc<ListNode>> {
self.tree.root().descendants().find_map(|node| {
let value = node.value();
if value.name == name && !node.has_children() {
Some(value.clone())
} else {
None
}
})
}
}

View File

@ -12,9 +12,6 @@ installMeld() {
apt-get|nala) apt-get|nala)
"$ESCALATION_TOOL" "$PACKAGER" -y install meld "$ESCALATION_TOOL" "$PACKAGER" -y install meld
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add meld
;;
*) *)
checkFlatpak checkFlatpak
flatpak install -y flathub org.gnome.meld flatpak install -y flathub org.gnome.meld

View File

@ -29,9 +29,6 @@ installNeovim() {
dnf|zypper) dnf|zypper)
"$ESCALATION_TOOL" "$PACKAGER" install -y neovim ripgrep fzf python3-virtualenv luarocks golang ShellCheck git "$ESCALATION_TOOL" "$PACKAGER" install -y neovim ripgrep fzf python3-virtualenv luarocks golang ShellCheck git
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add neovim ripgrep fzf py3-virtualenv luarocks go shellcheck git
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installVsCode() { installVsCode() {
if ! command_exists com.visualstudio.code && ! command_exists code; then if ! command_exists code; then
printf "%b\n" "${YELLOW}Installing VS Code..${RC}." printf "%b\n" "${YELLOW}Installing VS Code..${RC}."
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -28,10 +28,6 @@ installVsCode() {
printf "%b\n" '[code]\nname=Visual Studio Code\nbaseurl=https://packages.microsoft.com/yumrepos/vscode\nenabled=1\ngpgcheck=1\ngpgkey=https://packages.microsoft.com/keys/microsoft.asc' | "$ESCALATION_TOOL" tee /etc/yum.repos.d/vscode.repo > /dev/null printf "%b\n" '[code]\nname=Visual Studio Code\nbaseurl=https://packages.microsoft.com/yumrepos/vscode\nenabled=1\ngpgcheck=1\ngpgkey=https://packages.microsoft.com/keys/microsoft.asc' | "$ESCALATION_TOOL" tee /etc/yum.repos.d/vscode.repo > /dev/null
"$ESCALATION_TOOL" "$PACKAGER" install -y code "$ESCALATION_TOOL" "$PACKAGER" install -y code
;; ;;
apk)
checkFlatpak
flatpak install -y flathub com.visualstudio.code
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installVsCodium() { installVsCodium() {
if ! command_exists com.vscodium.codium && ! command_exists codium; then if ! command_exists codium; then
printf "%b\n" "${YELLOW}Installing VS Codium...${RC}" printf "%b\n" "${YELLOW}Installing VS Codium...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -26,10 +26,6 @@ installVsCodium() {
printf "%b\n" "[gitlab.com_paulcarroty_vscodium_repo]\nname=download.vscodium.com\nbaseurl=https://download.vscodium.com/rpms/\nenabled=1\ngpgcheck=1\nrepo_gpgcheck=1\ngpgkey=https://gitlab.com/paulcarroty/vscodium-deb-rpm-repo/-/raw/master/pub.gpg\nmetadata_expire=1h" | "$ESCALATION_TOOL" tee -a /etc/yum.repos.d/vscodium.repo printf "%b\n" "[gitlab.com_paulcarroty_vscodium_repo]\nname=download.vscodium.com\nbaseurl=https://download.vscodium.com/rpms/\nenabled=1\ngpgcheck=1\nrepo_gpgcheck=1\ngpgkey=https://gitlab.com/paulcarroty/vscodium-deb-rpm-repo/-/raw/master/pub.gpg\nmetadata_expire=1h" | "$ESCALATION_TOOL" tee -a /etc/yum.repos.d/vscodium.repo
"$ESCALATION_TOOL" "$PACKAGER" install -y codium "$ESCALATION_TOOL" "$PACKAGER" install -y codium
;; ;;
apk)
checkFlatpak
flatpak install -y flathub com.vscodium.codium
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -9,9 +9,6 @@ installAlacritty() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm alacritty "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm alacritty
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add alacritty
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y alacritty "$ESCALATION_TOOL" "$PACKAGER" install -y alacritty
;; ;;

View File

@ -15,9 +15,6 @@ install_adb() {
dnf|zypper) dnf|zypper)
"$ESCALATION_TOOL" "$PACKAGER" install -y android-tools "$ESCALATION_TOOL" "$PACKAGER" install -y android-tools
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add android-tools
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: "$PACKAGER"${RC}" printf "%b\n" "${RED}Unsupported package manager: "$PACKAGER"${RC}"
exit 1 exit 1

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installBrave() { installBrave() {
if ! command_exists com.brave.Browser && ! command_exists brave; then if ! command_exists brave; then
printf "%b\n" "${YELLOW}Installing Brave...${RC}" printf "%b\n" "${YELLOW}Installing Brave...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -29,10 +29,6 @@ installBrave() {
"$ESCALATION_TOOL" rpm --import https://brave-browser-rpm-release.s3.brave.com/brave-core.asc "$ESCALATION_TOOL" rpm --import https://brave-browser-rpm-release.s3.brave.com/brave-core.asc
"$ESCALATION_TOOL" "$PACKAGER" install -y brave-browser "$ESCALATION_TOOL" "$PACKAGER" install -y brave-browser
;; ;;
apk)
checkFlatpak
flatpak install -y flathub com.brave.Browser
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -9,9 +9,6 @@ if ! command_exists chromium; then
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm chromium "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm chromium
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add chromium
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y chromium "$ESCALATION_TOOL" "$PACKAGER" install -y chromium
;; ;;

View File

@ -18,9 +18,6 @@ installFirefox() {
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y firefox "$ESCALATION_TOOL" "$PACKAGER" install -y firefox
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add firefox
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installLibreWolf() { installLibreWolf() {
if ! command_exists io.gitlab.librewolf-community && ! command_exists librewolf; then if ! command_exists librewolf; then
printf "%b\n" "${YELLOW}Installing Librewolf...${RC}" printf "%b\n" "${YELLOW}Installing Librewolf...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -32,10 +32,6 @@ Signed-By: /usr/share/keyrings/librewolf.gpg" | "$ESCALATION_TOOL" tee /etc/apt/
pacman) pacman)
"$AUR_HELPER" -S --needed --noconfirm librewolf-bin "$AUR_HELPER" -S --needed --noconfirm librewolf-bin
;; ;;
apk)
checkFlatpak
flatpak install flathub io.gitlab.librewolf-community
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -9,9 +9,6 @@ installLynx() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm lynx "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm lynx
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add lynx
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y lynx "$ESCALATION_TOOL" "$PACKAGER" install -y lynx
;; ;;

View File

@ -22,7 +22,6 @@ installThrorium() {
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1
;; ;;
esac esac
else else

View File

@ -1,34 +0,0 @@
#!/bin/sh -e
. ../../common-script.sh
installTorBrowser() {
if ! command_exists torbrowser-launcher; then
printf "%b\n" "${YELLOW}Installing Tor Browser...${RC}"
case "$PACKAGER" in
apt-get|nala)
"$ESCALATION_TOOL" "$PACKAGER" install -y torbrowser-launcher
;;
zypper)
"$ESCALATION_TOOL" "$PACKAGER" --non-interactive install torbrowser-launcher
;;
pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm torbrowser-launcher
;;
dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y torbrowser-launcher
;;
*)
printf "%b\n" "${RED}Unsupported package manager: ${PACKAGER}${RC}"
exit 1
;;
esac
else
printf "%b\n" "${GREEN}Tor Browser is already installed.${RC}"
fi
}
checkEnv
checkEscalationTool
installTorBrowser

View File

@ -3,14 +3,14 @@
. ../../common-script.sh . ../../common-script.sh
installWaterfox() { installWaterfox() {
if ! command_exists net.waterfox.waterfox && ! command_exists waterfox; then if ! command_exists waterfox; then
printf "%b\n" "${YELLOW}Installing waterfox...${RC}" printf "%b\n" "${YELLOW}Installing waterfox...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
pacman) pacman)
"$AUR_HELPER" -S --needed --noconfirm waterfox-bin "$AUR_HELPER" -S --needed --noconfirm waterfox-bin
;; ;;
*) *)
checkFlatpak . ../setup-flatpak.sh
flatpak install -y flathub net.waterfox.waterfox flatpak install -y flathub net.waterfox.waterfox
;; ;;
esac esac

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installDiscord() { installDiscord() {
if ! command_exists com.discordapp.Discord && ! command_exists discord; then if ! command_exists discord; then
printf "%b\n" "${YELLOW}Installing Discord...${RC}" printf "%b\n" "${YELLOW}Installing Discord...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -20,10 +20,6 @@ installDiscord() {
"$ESCALATION_TOOL" "$PACKAGER" install -y https://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm "$ESCALATION_TOOL" "$PACKAGER" install -y https://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm
"$ESCALATION_TOOL" "$PACKAGER" install -y discord "$ESCALATION_TOOL" "$PACKAGER" install -y discord
;; ;;
apk)
checkFlatpak
flatpak install -y flathub com.discordapp.Discord
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -3,7 +3,7 @@
. ../../common-script.sh . ../../common-script.sh
installJitsi() { installJitsi() {
if ! command_exists org.jitsi.jitsi-meet && ! command_exists jitsi-meet; then if ! command_exists jitsi-meet; then
printf "%b\n" "${YELLOW}Installing Jitsi meet...${RC}" printf "%b\n" "${YELLOW}Installing Jitsi meet...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
@ -21,10 +21,6 @@ installJitsi() {
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y jitsi-meet "$ESCALATION_TOOL" "$PACKAGER" install -y jitsi-meet
;; ;;
apk)
checkFlatpak
flatpak install flathub org.jitsi.jitsi-meet
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -23,10 +23,6 @@ installSignal() {
checkFlatpak checkFlatpak
flatpak install -y flathub org.signal.Signal flatpak install -y flathub org.signal.Signal
;; ;;
apk)
checkFlatpak
flatpak install -y flathub org.signal.Signal
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -9,9 +9,6 @@ installTelegram() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm telegram-desktop "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm telegram-desktop
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add telegram-desktop
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y telegram-desktop "$ESCALATION_TOOL" "$PACKAGER" install -y telegram-desktop
;; ;;

View File

@ -9,9 +9,6 @@ installThunderBird() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm thunderbird "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm thunderbird
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add thunderbird
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y thunderbird "$ESCALATION_TOOL" "$PACKAGER" install -y thunderbird
;; ;;

View File

@ -1,23 +0,0 @@
#!/bin/sh -e
. ../../common-script.sh
installZapZap() {
if ! command_exists com.rtosta.zapzap && ! command_exists zapzap; then
printf "%b\n" "${YELLOW}Installing Zap-Zap...${RC}"
case "$PACKAGER" in
pacman)
"$AUR_HELPER" -S --needed --noconfirm zapzap
;;
*)
checkFlatpak
flatpak install flathub com.rtosta.zapzap
;;
esac
else
printf "%b\n" "${GREEN}Zap-Zap is already installed.${RC}"
fi
}
checkEnv
installZapZap

View File

@ -1,10 +1,10 @@
#!/bin/sh -e #!/bin/sh -e
. ../common-script.sh . ../common-script.sh
. ../common-service-script.sh
# Function to prompt the user for installation choice # Function to prompt the user for installation choice
choose_installation() { choose_installation() {
clear
printf "%b\n" "${YELLOW}Choose what to install:${RC}" printf "%b\n" "${YELLOW}Choose what to install:${RC}"
printf "%b\n" "1. ${YELLOW}Docker${RC}" printf "%b\n" "1. ${YELLOW}Docker${RC}"
printf "%b\n" "2. ${YELLOW}Docker Compose${RC}" printf "%b\n" "2. ${YELLOW}Docker Compose${RC}"
@ -34,20 +34,19 @@ install_docker() {
;; ;;
zypper) zypper)
"$ESCALATION_TOOL" "$PACKAGER" --non-interactive install docker "$ESCALATION_TOOL" "$PACKAGER" --non-interactive install docker
"$ESCALATION_TOOL" systemctl enable docker
"$ESCALATION_TOOL" systemctl start docker
;; ;;
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --noconfirm docker "$ESCALATION_TOOL" "$PACKAGER" -S --noconfirm docker
;; "$ESCALATION_TOOL" systemctl enable docker
apk) "$ESCALATION_TOOL" systemctl start docker
"$ESCALATION_TOOL" "$PACKAGER" add docker
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1
;; ;;
esac esac
startAndEnableService docker
} }
install_docker_compose() { install_docker_compose() {
@ -67,9 +66,6 @@ install_docker_compose() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm docker-compose "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm docker-compose
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add docker-cli-compose
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -6,7 +6,7 @@ setupDWM() {
printf "%b\n" "${YELLOW}Installing DWM-Titus...${RC}" printf "%b\n" "${YELLOW}Installing DWM-Titus...${RC}"
case "$PACKAGER" in # Install pre-Requisites case "$PACKAGER" in # Install pre-Requisites
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm base-devel libx11 libxinerama libxft imlib2 libxcb git unzip flameshot lxappearance feh mate-polkit meson libev uthash libconfig "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm base-devel libx11 libxinerama libxft imlib2 libxcb git unzip flameshot lxappearance feh mate-polkit
;; ;;
apt-get|nala) apt-get|nala)
"$ESCALATION_TOOL" "$PACKAGER" install -y build-essential libx11-dev libxinerama-dev libxft-dev libimlib2-dev libx11-xcb-dev libfontconfig1 libx11-6 libxft2 libxinerama1 libxcb-res0-dev git unzip flameshot lxappearance feh mate-polkit "$ESCALATION_TOOL" "$PACKAGER" install -y build-essential libx11-dev libxinerama-dev libxft-dev libimlib2-dev libx11-xcb-dev libfontconfig1 libx11-6 libxft2 libxinerama1 libxcb-res0-dev git unzip flameshot lxappearance feh mate-polkit

View File

@ -14,9 +14,6 @@ installFastfetch() {
"$ESCALATION_TOOL" "$PACKAGER" install -y /tmp/fastfetch.deb "$ESCALATION_TOOL" "$PACKAGER" install -y /tmp/fastfetch.deb
rm /tmp/fastfetch.deb rm /tmp/fastfetch.deb
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add fastfetch
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y fastfetch "$ESCALATION_TOOL" "$PACKAGER" install -y fastfetch
;; ;;

View File

@ -9,9 +9,6 @@ installKitty() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm kitty "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm kitty
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add kitty
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y kitty "$ESCALATION_TOOL" "$PACKAGER" install -y kitty
;; ;;

View File

@ -25,10 +25,6 @@ installLinutil() {
esac esac
printf "%b\n" "${GREEN}Installed successfully.${RC}" printf "%b\n" "${GREEN}Installed successfully.${RC}"
;; ;;
zypper)
"$ESCALATION_TOOL" "$PACKAGER" install linutil -y
printf "%b\n" "${GREEN}Installed successfully.${RC}"
;;
*) *)
printf "%b\n" "${RED}There are no official packages for your distro.${RC}" printf "%b\n" "${RED}There are no official packages for your distro.${RC}"
printf "%b" "${YELLOW}Do you want to install the crates.io package? (y/N): ${RC}" printf "%b" "${YELLOW}Do you want to install the crates.io package? (y/N): ${RC}"
@ -44,12 +40,10 @@ installLinutil() {
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y curl rustup man-pages man-db man "$ESCALATION_TOOL" "$PACKAGER" install -y curl rustup man-pages man-db man
;; ;;
apk) zypper)
"$ESCALATION_TOOL" "$PACKAGER" add build-base "$ESCALATION_TOOL" "$PACKAGER" install -n curl gcc make
"$ESCALATION_TOOL" "$PACKAGER" add rustup curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- -y
rustup-init . $HOME/.cargo/env
# shellcheck disable=SC1091
. "$HOME/.cargo/env"
;; ;;
*) *)
curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- -y curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh -s -- -y

View File

@ -19,13 +19,6 @@ updateLinutil() {
curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh
. $HOME/.cargo/env . $HOME/.cargo/env
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add build-base
"$ESCALATION_TOOL" "$PACKAGER" add rustup
rustup-init
# shellcheck disable=SC1091
. "$HOME/.cargo/env"
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y rustup "$ESCALATION_TOOL" "$PACKAGER" install -y rustup
;; ;;

View File

@ -11,9 +11,6 @@ installDepend() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm bash bash-completion tar bat tree unzip fontconfig git "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm bash bash-completion tar bat tree unzip fontconfig git
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add bash bash-completion tar bat tree unzip fontconfig git
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y bash bash-completion tar bat tree unzip fontconfig git "$ESCALATION_TOOL" "$PACKAGER" install -y bash bash-completion tar bat tree unzip fontconfig git
;; ;;
@ -57,7 +54,7 @@ installStarshipAndFzf() {
return return
fi fi
if ! curl -sSL https://starship.rs/install.sh | "$ESCALATION_TOOL" sh; then if ! curl -sSL https://starship.rs/install.sh | sh; then
printf "%b\n" "${RED}Something went wrong during starship install!${RC}" printf "%b\n" "${RED}Something went wrong during starship install!${RC}"
exit 1 exit 1
fi fi

View File

@ -16,9 +16,6 @@ installLibreOffice() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm libreoffice-fresh "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm libreoffice-fresh
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add libreoffice
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -9,9 +9,6 @@ installEvince() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm evince "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm evince
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add evince
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y evince "$ESCALATION_TOOL" "$PACKAGER" install -y evince
;; ;;

View File

@ -9,9 +9,6 @@ installOkular() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm okular "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm okular
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add okular
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y okular "$ESCALATION_TOOL" "$PACKAGER" install -y okular
;; ;;

View File

@ -9,9 +9,6 @@ installRofi() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm rofi "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm rofi
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add rofi
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y rofi "$ESCALATION_TOOL" "$PACKAGER" install -y rofi
;; ;;

View File

@ -84,17 +84,6 @@ description = "Sublime Text is a fast, lightweight, and customizable text editor
script = "Developer-tools/sublime-setup.sh" script = "Developer-tools/sublime-setup.sh"
task_list = "I" task_list = "I"
[[data.entries]]
name = "ZapZap"
description = "ZapZap is an open source whatsapp desktop client for Linux users developed by rafatosta."
script = "communication-apps/zapzap-setup.sh"
task_list = "I"
[[data.entries]]
name = "Zoom"
description = "Zoom is a widely-used video conferencing platform that allows users to host virtual meetings, webinars, and online collaboration with features like screen sharing and recording."
script = "communication-apps/zoom-setup.sh"
[[data.entries]] [[data.entries]]
name = "VS Code" name = "VS Code"
description = "Visual Studio Code (VS Code) is a lightweight, open-source code editor with built-in support for debugging, version control, and extensions for various programming languages and frameworks." description = "Visual Studio Code (VS Code) is a lightweight, open-source code editor with built-in support for debugging, version control, and extensions for various programming languages and frameworks."
@ -203,12 +192,6 @@ description = "Vivaldi is a freeware, cross-platform web browser developed by Vi
script = "browsers/vivaldi.sh" script = "browsers/vivaldi.sh"
task_list = "I" task_list = "I"
[[data.entries]]
name = "Tor Browser"
description = "Tor Browser is a free and open-source firefox-based web browser designed for anonymity and censorship circumvention."
script = "browsers/tor-browser.sh"
task_list = "I"
[[data.entries]] [[data.entries]]
name = "waterfox" name = "waterfox"
description = "Waterfox is the privacy-focused web browser engineered to give you speed, control, and peace of mind on the internet." description = "Waterfox is the privacy-focused web browser engineered to give you speed, control, and peace of mind on the internet."

View File

@ -10,9 +10,6 @@ installZsh() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm zsh "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm zsh
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add zsh
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y zsh "$ESCALATION_TOOL" "$PACKAGER" install -y zsh
;; ;;

View File

@ -123,12 +123,6 @@ checkPackageManager() {
fi fi
done done
## Enable apk community packages
if [ "$PACKAGER" = "apk" ] && grep -qE '^#.*community' /etc/apk/repositories; then
"$ESCALATION_TOOL" sed -i '/community/s/^#//' /etc/apk/repositories
"$ESCALATION_TOOL" "$PACKAGER" update
fi
if [ -z "$PACKAGER" ]; then if [ -z "$PACKAGER" ]; then
printf "%b\n" "${RED}Can't find a supported package manager${RC}" printf "%b\n" "${RED}Can't find a supported package manager${RC}"
exit 1 exit 1
@ -175,7 +169,7 @@ checkEnv() {
checkArch checkArch
checkEscalationTool checkEscalationTool
checkCommandRequirements "curl groups $ESCALATION_TOOL" checkCommandRequirements "curl groups $ESCALATION_TOOL"
checkPackageManager 'nala apt-get dnf pacman zypper apk' checkPackageManager 'nala apt-get dnf pacman zypper'
checkCurrentDirectoryWritable checkCurrentDirectoryWritable
checkSuperUser checkSuperUser
checkDistro checkDistro

View File

@ -1,85 +0,0 @@
#!/bin/sh -e
checkInitManager() {
for manager in $1; do
if command_exists "$manager"; then
INIT_MANAGER="$manager"
printf "%b\n" "${CYAN}Using ${manager} to interact with init system${RC}"
break
fi
done
if [ -z "$INIT_MANAGER" ]; then
printf "%b\n" "${RED}Can't find a supported init system${RC}"
exit 1
fi
}
startService() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" start "$1"
;;
rc-service)
"$ESCALATION_TOOL" "$INIT_MANAGER" "$1" start
;;
esac
}
stopService() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" stop "$1"
;;
rc-service)
"$ESCALATION_TOOL" "$INIT_MANAGER" "$1" stop
;;
esac
}
enableService() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" enable "$1"
;;
rc-service)
"$ESCALATION_TOOL" rc-update add "$1"
;;
esac
}
disableService() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" disable "$1"
;;
rc-service)
"$ESCALATION_TOOL" rc-update del "$1"
;;
esac
}
startAndEnableService() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" enable --now "$1"
;;
rc-service)
enableService "$1"
startService "$1"
;;
esac
}
isServiceActive() {
case "$INIT_MANAGER" in
systemctl)
"$ESCALATION_TOOL" "$INIT_MANAGER" is-active --quiet "$1"
;;
rc-service)
"$ESCALATION_TOOL" "$INIT_MANAGER" "$1" status --quiet
;;
esac
}
checkInitManager 'systemctl rc-service'

View File

@ -9,9 +9,6 @@ installPkg() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm ufw "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm ufw
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add ufw
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y ufw "$ESCALATION_TOOL" "$PACKAGER" install -y ufw
;; ;;

View File

@ -5,8 +5,3 @@ name = "Firewall Baselines (CTT)"
description = "Developed to ease iptables firewall configuration, UFW provides a user friendly way to create an IPv4 or IPv6 host-based firewall. This command installs UFW and configures UFW based on CTT's recommended rules. For more information visit: https://christitus.com/linux-security-mistakes" description = "Developed to ease iptables firewall configuration, UFW provides a user friendly way to create an IPv4 or IPv6 host-based firewall. This command installs UFW and configures UFW based on CTT's recommended rules. For more information visit: https://christitus.com/linux-security-mistakes"
script = "firewall-baselines.sh" script = "firewall-baselines.sh"
task_list = "I SS" task_list = "I SS"
[[data.preconditions]]
matches = false
data = "command_exists"
values = [ "firewalld" ]

View File

@ -1,104 +0,0 @@
#!/bin/sh -e
. ../../common-script.sh
installQEMUDesktop() {
if ! command_exists qemu-img; then
printf "%b\n" "${YELLOW}Installing QEMU.${RC}"
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm qemu-desktop
else
printf "%b\n" "${GREEN}QEMU is already installed.${RC}"
fi
checkKVM
}
installQEMUEmulators() {
if ! "$PACKAGER" -Q | grep -q "qemu-emulators-full "; then
printf "%b\n" "${YELLOW}Installing QEMU-Emulators.${RC}"
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm qemu-emulators-full swtpm
else
printf "%b\n" "${GREEN}QEMU-Emulators already installed.${RC}"
fi
}
installVirtManager() {
if ! command_exists virt-manager; then
printf "%b\n" "${YELLOW}Installing Virt-Manager.${RC}"
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm virt-manager
else
printf "%b\n" "${GREEN}Virt-Manager already installed.${RC}"
fi
}
checkKVM() {
if [ ! -e "/dev/kvm" ]; then
printf "%b\n" "${RED}KVM is not available. Make sure you have CPU virtualization support enabled in your BIOS/UEFI settings. Please refer https://wiki.archlinux.org/title/KVM for more information.${RC}"
else
"$ESCALATION_TOOL" usermod "$USER" -aG kvm
fi
}
setupLibvirt() {
printf "%b\n" "${YELLOW}Configuring Libvirt.${RC}"
if "$PACKAGER" -Q | grep -q "iptables "; then
"$ESCALATION_TOOL" "$PACKAGER" -Rdd --noconfirm iptables
fi
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm dnsmasq iptables-nft
"$ESCALATION_TOOL" sed -i 's/^#\?firewall_backend\s*=\s*".*"/firewall_backend = "iptables"/' "/etc/libvirt/network.conf"
if systemctl is-active --quiet polkit; then
"$ESCALATION_TOOL" sed -i 's/^#\?auth_unix_ro\s*=\s*".*"/auth_unix_ro = "polkit"/' "/etc/libvirt/libvirtd.conf"
"$ESCALATION_TOOL" sed -i 's/^#\?auth_unix_rw\s*=\s*".*"/auth_unix_rw = "polkit"/' "/etc/libvirt/libvirtd.conf"
fi
"$ESCALATION_TOOL" usermod "$USER" -aG libvirt
for value in libvirt libvirt_guest; do
if ! grep -wq "$value" /etc/nsswitch.conf; then
"$ESCALATION_TOOL" sed -i "/^hosts:/ s/$/ ${value}/" /etc/nsswitch.conf
fi
done
"$ESCALATION_TOOL" systemctl enable --now libvirtd.service
"$ESCALATION_TOOL" virsh net-autostart default
checkKVM
}
installLibvirt() {
if ! command_exists libvirtd; then
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm libvirt dmidecode
else
printf "%b\n" "${GREEN}Libvirt is already installed.${RC}"
fi
setupLibvirt
}
main() {
printf "%b\n" "${YELLOW}Choose what to install:${RC}"
printf "%b\n" "1. ${YELLOW}QEMU${RC}"
printf "%b\n" "2. ${YELLOW}QEMU-Emulators ( Extended architectures )${RC}"
printf "%b\n" "3. ${YELLOW}Libvirt${RC}"
printf "%b\n" "4. ${YELLOW}Virtual-Manager${RC}"
printf "%b\n" "5. ${YELLOW}All${RC}"
printf "%b" "Enter your choice [1-5]: "
read -r CHOICE
case "$CHOICE" in
1) installQEMUDesktop ;;
2) installQEMUEmulators ;;
3) installLibvirt ;;
4) installVirtManager ;;
5)
installQEMUDesktop
installQEMUEmulators
installLibvirt
installVirtManager
;;
*) printf "%b\n" "${RED}Invalid choice.${RC}" && exit 1 ;;
esac
}
checkEnv
checkEscalationTool
main

View File

@ -37,9 +37,6 @@ installDepend() {
"$ESCALATION_TOOL" "$PACKAGER" --non-interactive install $DEPENDENCIES $COMPILEDEPS "$ESCALATION_TOOL" "$PACKAGER" --non-interactive install $DEPENDENCIES $COMPILEDEPS
"$ESCALATION_TOOL" "$PACKAGER" --non-interactive install libgcc_s1-gcc7-32bit glibc-devel-32bit "$ESCALATION_TOOL" "$PACKAGER" --non-interactive install libgcc_s1-gcc7-32bit glibc-devel-32bit
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add build-base multitail tar tree trash-cli unzip cmake jq
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y $DEPENDENCIES "$ESCALATION_TOOL" "$PACKAGER" install -y $DEPENDENCIES
;; ;;

View File

@ -8,6 +8,8 @@ multimedia() {
if [ -e /etc/yum.repos.d/rpmfusion-free.repo ] && [ -e /etc/yum.repos.d/rpmfusion-nonfree.repo ]; then if [ -e /etc/yum.repos.d/rpmfusion-free.repo ] && [ -e /etc/yum.repos.d/rpmfusion-nonfree.repo ]; then
printf "%b\n" "${YELLOW}Installing Multimedia Codecs...${RC}" printf "%b\n" "${YELLOW}Installing Multimedia Codecs...${RC}"
"$ESCALATION_TOOL" "$PACKAGER" swap ffmpeg-free ffmpeg --allowerasing -y "$ESCALATION_TOOL" "$PACKAGER" swap ffmpeg-free ffmpeg --allowerasing -y
"$ESCALATION_TOOL" "$PACKAGER" update @multimedia --setopt="install_weak_deps=False" --exclude=PackageKit-gstreamer-plugin -y
"$ESCALATION_TOOL" "$PACKAGER" update @sound-and-video -y
printf "%b\n" "${GREEN}Multimedia Codecs Installed...${RC}" printf "%b\n" "${GREEN}Multimedia Codecs Installed...${RC}"
else else
printf "%b\n" "${RED}RPM Fusion repositories not found. Please set up RPM Fusion first!${RC}" printf "%b\n" "${RED}RPM Fusion repositories not found. Please set up RPM Fusion first!${RC}"

View File

@ -1,11 +1,10 @@
#!/bin/sh -e #!/bin/sh -e
# shellcheck disable=SC2086
. ../common-script.sh . ../common-script.sh
installDepend() { installDepend() {
DEPENDENCIES='wine dbus git' # Check for dependencies
DEPENDENCIES='wine dbus'
printf "%b\n" "${YELLOW}Installing dependencies...${RC}" printf "%b\n" "${YELLOW}Installing dependencies...${RC}"
case "$PACKAGER" in case "$PACKAGER" in
pacman) pacman)
@ -29,13 +28,10 @@ installDepend() {
apt-get|nala) apt-get|nala)
DISTRO_DEPS="libasound2-plugins:i386 libsdl2-2.0-0:i386 libdbus-1-3:i386 libsqlite3-0:i386 wine64 wine32" DISTRO_DEPS="libasound2-plugins:i386 libsdl2-2.0-0:i386 libdbus-1-3:i386 libsqlite3-0:i386 wine64 wine32"
"$ESCALATION_TOOL" "$PACKAGER" update
"$ESCALATION_TOOL" dpkg --add-architecture i386 "$ESCALATION_TOOL" dpkg --add-architecture i386
if [ "$DTYPE" != "pop" ]; then
"$ESCALATION_TOOL" "$PACKAGER" install -y software-properties-common "$ESCALATION_TOOL" "$PACKAGER" install -y software-properties-common
"$ESCALATION_TOOL" apt-add-repository contrib -y "$ESCALATION_TOOL" apt-add-repository contrib -y
fi
"$ESCALATION_TOOL" "$PACKAGER" update "$ESCALATION_TOOL" "$PACKAGER" update
"$ESCALATION_TOOL" "$PACKAGER" install -y $DEPENDENCIES $DISTRO_DEPS "$ESCALATION_TOOL" "$PACKAGER" install -y $DEPENDENCIES $DISTRO_DEPS
;; ;;
@ -54,8 +50,7 @@ installDepend() {
"$ESCALATION_TOOL" "$PACKAGER" -n install $DEPENDENCIES "$ESCALATION_TOOL" "$PACKAGER" -n install $DEPENDENCIES
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager ${PACKAGER}${RC}" "$ESCALATION_TOOL" "$PACKAGER" install -y $DEPENDENCIES
exit 1
;; ;;
esac esac
} }
@ -76,7 +71,7 @@ installAdditionalDepend() {
curl -sSLo "lutris_${version_no_v}_all.deb" "https://github.com/lutris/lutris/releases/download/${version}/lutris_${version_no_v}_all.deb" curl -sSLo "lutris_${version_no_v}_all.deb" "https://github.com/lutris/lutris/releases/download/${version}/lutris_${version_no_v}_all.deb"
printf "%b\n" "${YELLOW}Installing Lutris...${RC}" printf "%b\n" "${YELLOW}Installing Lutris...${RC}"
"$ESCALATION_TOOL" "$PACKAGER" install -y ./lutris_"${version_no_v}"_all.deb "$ESCALATION_TOOL" "$PACKAGER" install ./lutris_"${version_no_v}"_all.deb
rm lutris_"${version_no_v}"_all.deb rm lutris_"${version_no_v}"_all.deb
@ -95,12 +90,11 @@ installAdditionalDepend() {
"$ESCALATION_TOOL" "$PACKAGER" install -y $DISTRO_DEPS "$ESCALATION_TOOL" "$PACKAGER" install -y $DISTRO_DEPS
;; ;;
zypper) zypper)
# Flatpak
DISTRO_DEPS='lutris' DISTRO_DEPS='lutris'
"$ESCALATION_TOOL" "$PACKAGER" -n install $DISTRO_DEPS "$ESCALATION_TOOL" "$PACKAGER" -n install $DISTRO_DEPS
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager ${PACKAGER}${RC}"
exit 1
;; ;;
esac esac
} }

View File

@ -1,7 +1,6 @@
#!/bin/sh -e #!/bin/sh -e
. ../common-script.sh . ../common-script.sh
. ../common-service-script.sh
cleanup_system() { cleanup_system() {
printf "%b\n" "${YELLOW}Performing system cleanup...${RC}" printf "%b\n" "${YELLOW}Performing system cleanup...${RC}"
@ -22,10 +21,7 @@ cleanup_system() {
;; ;;
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -Sc --noconfirm "$ESCALATION_TOOL" "$PACKAGER" -Sc --noconfirm
"$ESCALATION_TOOL" "$PACKAGER" -Rns $(pacman -Qtdq) --noconfirm > /dev/null || true "$ESCALATION_TOOL" "$PACKAGER" -Rns $(pacman -Qtdq) --noconfirm > /dev/null 2>&1
;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" cache clean
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ${PACKAGER}. Skipping.${RC}" printf "%b\n" "${RED}Unsupported package manager: ${PACKAGER}. Skipping.${RC}"
@ -43,9 +39,7 @@ common_cleanup() {
if [ -d /var/log ]; then if [ -d /var/log ]; then
"$ESCALATION_TOOL" find /var/log -type f -name "*.log" -exec truncate -s 0 {} \; "$ESCALATION_TOOL" find /var/log -type f -name "*.log" -exec truncate -s 0 {} \;
fi fi
if [ "$INIT_MANAGER" = "systemctl" ]; then
"$ESCALATION_TOOL" journalctl --vacuum-time=3d "$ESCALATION_TOOL" journalctl --vacuum-time=3d
fi
} }
clean_data() { clean_data() {

View File

@ -5,85 +5,77 @@
fastUpdate() { fastUpdate() {
case "$PACKAGER" in case "$PACKAGER" in
pacman) pacman)
"$AUR_HELPER" -S --needed --noconfirm rate-mirrors-bin
$AUR_HELPER -S --needed --noconfirm rate-mirrors-bin
printf "%b\n" "${YELLOW}Generating a new list of mirrors using rate-mirrors. This process may take a few seconds...${RC}" printf "%b\n" "${YELLOW}Generating a new list of mirrors using rate-mirrors. This process may take a few seconds...${RC}"
if [ -s "/etc/pacman.d/mirrorlist" ]; then if [ -s /etc/pacman.d/mirrorlist ]; then
"$ESCALATION_TOOL" cp /etc/pacman.d/mirrorlist /etc/pacman.d/mirrorlist.bak "$ESCALATION_TOOL" cp /etc/pacman.d/mirrorlist /etc/pacman.d/mirrorlist.bak
fi fi
# If for some reason DTYPE is still unknown use always arch so the rate-mirrors does not fail # If for some reason DTYPE is still unknown use always arch so the rate-mirrors does not fail
dtype_local="$DTYPE" dtype_local=${DTYPE}
if [ "$dtype_local" = "unknown" ]; then if [ "${DTYPE}" = "unknown" ]; then
dtype_local="arch" dtype_local="arch"
fi fi
if ! "$ESCALATION_TOOL" rate-mirrors --top-mirrors-number-to-retest=5 --disable-comments --save /etc/pacman.d/mirrorlist --allow-root "$dtype_local" > /dev/null || [ ! -s "/etc/pacman.d/mirrorlist" ]; then "$ESCALATION_TOOL" rate-mirrors --top-mirrors-number-to-retest=5 --disable-comments --save /etc/pacman.d/mirrorlist --allow-root ${dtype_local}
if [ $? -ne 0 ] || [ ! -s /etc/pacman.d/mirrorlist ]; then
printf "%b\n" "${RED}Rate-mirrors failed, restoring backup.${RC}" printf "%b\n" "${RED}Rate-mirrors failed, restoring backup.${RC}"
"$ESCALATION_TOOL" cp /etc/pacman.d/mirrorlist.bak /etc/pacman.d/mirrorlist "$ESCALATION_TOOL" cp /etc/pacman.d/mirrorlist.bak /etc/pacman.d/mirrorlist
fi fi
;; ;;
apt-get|nala) apt-get|nala)
if [ "$PACKAGER" = "apt-get" ]; then "$ESCALATION_TOOL" apt-get update
printf "%b\n" "${YELLOW}Installing nala for faster updates.${RC}" if ! command_exists nala; then
"$ESCALATION_TOOL" "$PACKAGER" update "$ESCALATION_TOOL" apt-get install -y nala || { printf "%b\n" "${YELLOW}Falling back to apt-get${RC}"; PACKAGER="apt-get"; }
if "$ESCALATION_TOOL" "$PACKAGER" install -y nala; then
PACKAGER="nala";
printf "%b\n" "${CYAN}Using $PACKAGER as package manager${RC}"
else
printf "%b\n" "${RED}Nala installation failed.${RC}"
printf "%b\n" "${YELLOW}Falling back to apt-get.${RC}"
fi
fi fi
if [ "$PACKAGER" = "nala" ]; then if [ "$PACKAGER" = "nala" ]; then
if [ -f "/etc/apt/sources.list.d/nala-sources.list" ]; then "$ESCALATION_TOOL" cp /etc/apt/sources.list /etc/apt/sources.list.bak
"$ESCALATION_TOOL" cp /etc/apt/sources.list.d/nala-sources.list /etc/apt/sources.list.d/nala-sources.list.bak "$ESCALATION_TOOL" nala update
fi PACKAGER="nala"
if ! "$ESCALATION_TOOL" nala fetch --auto -y || [ ! -s "/etc/apt/sources.list.d/nala-sources.list" ]; then
printf "%b\n" "${RED}Nala fetch failed, restoring backup.${RC}"
"$ESCALATION_TOOL" cp /etc/apt/sources.list.d/nala-sources.list.bak /etc/apt/sources.list.d/nala-sources.list
fi
fi fi
"$ESCALATION_TOOL" "$PACKAGER" upgrade -y
;; ;;
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" update -y "$ESCALATION_TOOL" "$PACKAGER" update -y
;; ;;
zypper) zypper)
"$ESCALATION_TOOL" "$PACKAGER" ref "$ESCALATION_TOOL" "$PACKAGER" ref
;; "$ESCALATION_TOOL" "$PACKAGER" --non-interactive dup
apk)
"$ESCALATION_TOOL" "$PACKAGER" update
;; ;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ${PACKAGER}${RC}" printf "%b\n" "${RED}Unsupported package manager: "$PACKAGER"${RC}"
exit 1 exit 1
;; ;;
esac esac
} }
updateSystem() { updateSystem() {
printf "%b\n" "${YELLOW}Updating system packages.${RC}" printf "%b\n" "${GREEN}Updating system${RC}"
case "$PACKAGER" in case "$PACKAGER" in
apt-get|nala) apt-get|nala)
"$ESCALATION_TOOL" "$PACKAGER" update
"$ESCALATION_TOOL" "$PACKAGER" upgrade -y "$ESCALATION_TOOL" "$PACKAGER" upgrade -y
;; ;;
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" update -y
"$ESCALATION_TOOL" "$PACKAGER" upgrade -y "$ESCALATION_TOOL" "$PACKAGER" upgrade -y
;; ;;
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -Sy --noconfirm --needed archlinux-keyring "$ESCALATION_TOOL" "$PACKAGER" -Sy --noconfirm --needed archlinux-keyring
"$AUR_HELPER" -Su --noconfirm "$ESCALATION_TOOL" "$PACKAGER" -Su --noconfirm
;; ;;
zypper) zypper)
"$ESCALATION_TOOL" "$PACKAGER" ref
"$ESCALATION_TOOL" "$PACKAGER" --non-interactive dup "$ESCALATION_TOOL" "$PACKAGER" --non-interactive dup
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" upgrade
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ${PACKAGER}${RC}" printf "%b\n" "${RED}Unsupported package manager: "$PACKAGER"${RC}"
exit 1 exit 1
;; ;;
esac esac
@ -91,8 +83,18 @@ updateSystem() {
updateFlatpaks() { updateFlatpaks() {
if command_exists flatpak; then if command_exists flatpak; then
printf "%b\n" "${YELLOW}Updating flatpak packages.${RC}" printf "%b\n" "${YELLOW}Updating installed Flathub apps...${RC}"
flatpak update -y installed_apps=$(flatpak list --app --columns=application)
if [ -z "$installed_apps" ]; then
printf "%b\n" "${RED}No Flathub apps are installed.${RC}"
return
fi
for app in $installed_apps; do
printf "%b\n" "${YELLOW}Updating $app...${RC}"
flatpak update -y "$app"
done
fi fi
} }

View File

@ -38,12 +38,6 @@ description = "Paru is your standard pacman wrapping AUR helper with lots of fea
script = "arch/paru-setup.sh" script = "arch/paru-setup.sh"
task_list = "I" task_list = "I"
[[data.entries]]
name = "Virtualization"
description = "QEMU, Libvirt, Virt-Manager installation and configuration."
script = "arch/virtualization.sh"
task_list = "FM I SS RP"
[[data.entries]] [[data.entries]]
name = "Yay AUR Helper" name = "Yay AUR Helper"
description = "Yet Another Yogurt - An AUR Helper Written in Go. To know more about AUR helpers visit: https://wiki.archlinux.org/title/AUR_helpers" description = "Yet Another Yogurt - An AUR Helper Written in Go. To know more about AUR helpers visit: https://wiki.archlinux.org/title/AUR_helpers"

View File

@ -1,7 +1,6 @@
#!/bin/sh -e #!/bin/sh -e
. ../common-script.sh . ../common-script.sh
. ../common-service-script.sh
# Function to check Bluez is installed # Function to check Bluez is installed
setupBluetooth() { setupBluetooth() {
@ -11,9 +10,6 @@ setupBluetooth() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --noconfirm bluez-utils "$ESCALATION_TOOL" "$PACKAGER" -S --noconfirm bluez-utils
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add bluez
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y bluez "$ESCALATION_TOOL" "$PACKAGER" install -y bluez
;; ;;
@ -22,7 +18,15 @@ setupBluetooth() {
printf "%b\n" "${GREEN}Bluez is already installed.${RC}" printf "%b\n" "${GREEN}Bluez is already installed.${RC}"
fi fi
startService bluetooth # Check if bluetooth service is running
if ! systemctl is-active --quiet bluetooth; then
printf "%b\n" "${YELLOW}Bluetooth service is not running. Starting it now...${RC}"
"$ESCALATION_TOOL" systemctl start bluetooth
if systemctl is-active --quiet bluetooth; then
printf "%b\n" "${GREEN}Bluetooth service started successfully.${RC}"
fi
fi
} }
# Function to display the main menu # Function to display the main menu

View File

@ -12,7 +12,6 @@ list_devices() {
printf "\n" printf "\n"
} }
# shellcheck disable=SC2086
installDependencies() { installDependencies() {
DEPENDENCIES="xz gzip bzip2 jq" DEPENDENCIES="xz gzip bzip2 jq"
if ! command_exists ${DEPENDENCIES}; then if ! command_exists ${DEPENDENCIES}; then
@ -24,8 +23,6 @@ installDependencies() {
"${ESCALATION_TOOL}" "${PACKAGER}" install -y ${DEPENDENCIES};; "${ESCALATION_TOOL}" "${PACKAGER}" install -y ${DEPENDENCIES};;
pacman) pacman)
"${ESCALATION_TOOL}" "${PACKAGER}" -S --noconfirm --needed ${DEPENDENCIES};; "${ESCALATION_TOOL}" "${PACKAGER}" -S --noconfirm --needed ${DEPENDENCIES};;
apk)
"${ESCALATION_TOOL}" "${PACKAGER}" add ${DEPENDENCIES};;
*) *)
printf "%b\n" "${RED}Unsupported package manager.${RC}" printf "%b\n" "${RED}Unsupported package manager.${RC}"
exit 1 exit 1

View File

@ -19,9 +19,6 @@ if ! command_exists openssl; then
zypper) zypper)
"$ESCALATION_TOOL" "$PACKAGER" install openssl "$ESCALATION_TOOL" "$PACKAGER" install openssl
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add openssl
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}" printf "%b\n" "${RED}Unsupported package manager: ""$PACKAGER""${RC}"
exit 1 exit 1

View File

@ -1,7 +1,6 @@
#!/bin/sh -e #!/bin/sh -e
. ../common-script.sh . ../common-script.sh
. ../common-service-script.sh
create_file() { create_file() {
printf "%b\n" "Creating script..." printf "%b\n" "Creating script..."
@ -34,11 +33,6 @@ EOF
} }
numlockSetup() { numlockSetup() {
if [ "$INIT_MANAGER" = "rc-service" ]; then
printf "%b\n" "${RED}Unsupported init system.${RC}"
exit 1
fi
if [ ! -f "/usr/local/bin/numlock" ]; then if [ ! -f "/usr/local/bin/numlock" ]; then
create_file create_file
fi fi
@ -50,10 +44,10 @@ numlockSetup() {
printf "%b" "Do you want to enable Numlock on boot? (y/N): " printf "%b" "Do you want to enable Numlock on boot? (y/N): "
read -r confirm read -r confirm
if [ "$confirm" = "y" ] || [ "$confirm" = "Y" ]; then if [ "$confirm" = "y" ] || [ "$confirm" = "Y" ]; then
enableService numlock "$ESCALATION_TOOL" systemctl enable numlock.service --quiet
printf "%b\n" "Numlock will be enabled on boot" printf "%b\n" "Numlock will be enabled on boot"
else else
disableService numlock "$ESCALATION_TOOL" systemctl disable numlock.service --quiet
printf "%b\n" "Numlock will not be enabled on boot" printf "%b\n" "Numlock will not be enabled on boot"
fi fi
} }

View File

@ -10,8 +10,8 @@ installollama() {
printf "%b\n" "${GREEN}ollama is already installed.${RC}" printf "%b\n" "${GREEN}ollama is already installed.${RC}"
else else
printf "%b\n" "${YELLOW}Installing ollama...${RC}" printf "%b\n" "${YELLOW}Installing ollama...${RC}"
curl -fsSL https://ollama.com/install.sh | "$ESCALATION_TOOL" sh curl -fsSL https://ollama.com/install.sh | sh
"$ESCALATION_TOOL" startService ollama "$ESCALATION_TOOL" systemctl start ollama
fi fi
} }

View File

@ -19,9 +19,6 @@ installAutoCpufreq() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm git "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm git
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add git
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y git "$ESCALATION_TOOL" "$PACKAGER" install -y git
;; ;;
@ -48,7 +45,7 @@ configureAutoCpufreq() {
if command_exists auto-cpufreq; then if command_exists auto-cpufreq; then
# Check if the system has a battery to determine if it's a laptop # Check if the system has a battery to determine if it's a laptop
if ls /sys/class/power_supply/BAT* >/dev/null 2>&1; then if [ -d /sys/class/power_supply/BAT0 ]; then
printf "%b\n" "${GREEN}System detected as laptop. Updating auto-cpufreq for laptop...${RC}" printf "%b\n" "${GREEN}System detected as laptop. Updating auto-cpufreq for laptop...${RC}"
"$ESCALATION_TOOL" auto-cpufreq --force powersave "$ESCALATION_TOOL" auto-cpufreq --force powersave
else else

View File

@ -1,27 +0,0 @@
#!/bin/sh -e
. ../../common-script.sh
installCUPS() {
clear
case "$PACKAGER" in
pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --noconfirm cups
;;
apt-get | nala)
"$ESCALATION_TOOL" "$PACKAGER" install -y cups
;;
dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y cups
;;
*)
printf "%b\n" "${RED}Unsupported package manager ${PACKAGER}${RC}"
exit 1
;;
esac
}
checkEnv
checkEscalationTool
installCUPS

View File

@ -1,30 +0,0 @@
#!/bin/sh -e
. ../../common-script.sh
. ./install-cups.sh
installEpsonPrinterDriver() {
clear
case "$PACKAGER" in
pacman)
"$AUR_HELPER" -S --noconfirm epson-inkjet-printer-escpr
;;
apt-get | nala)
"$ESCALATION_TOOL" "$PACKAGER" install -y printer-driver-escpr
;;
dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y epson-inkjet-printer-escpr
;;
*)
printf "%b\n" "${RED}Unsupported package manager ${PACKAGER}${RC}"
exit 1
;;
esac
}
checkEnv
checkEscalationTool
checkAURHelper
installCUPS
installEpsonPrinterDriver

View File

@ -11,9 +11,6 @@ install_package() {
pacman) pacman)
"$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm "$PACKAGE" "$ESCALATION_TOOL" "$PACKAGER" -S --needed --noconfirm "$PACKAGE"
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add "$PACKAGE"
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y "$PACKAGE" "$ESCALATION_TOOL" "$PACKAGER" install -y "$PACKAGE"
;; ;;
@ -37,23 +34,23 @@ setup_ssh() {
install_package openssh install_package openssh
SSH_SERVICE="sshd" SSH_SERVICE="sshd"
;; ;;
apk)
install_package openssh
SSH_SERVICE="sshd"
;;
*) *)
install_package openssh-server install_package openssh-server
SSH_SERVICE="sshd" SSH_SERVICE="sshd"
;; ;;
esac esac
startAndEnableService "$SSH_SERVICE" # Enable and start the appropriate SSH service
"$ESCALATION_TOOL" systemctl enable "$SSH_SERVICE"
"$ESCALATION_TOOL" systemctl start "$SSH_SERVICE"
# Get the local IP address
LOCAL_IP=$(ip -4 addr show | awk '/inet / {print $2}' | tail -n 1) LOCAL_IP=$(ip -4 addr show | awk '/inet / {print $2}' | tail -n 1)
printf "%b\n" "${GREEN}Your local IP address is: $LOCAL_IP${RC}" printf "%b\n" "${GREEN}Your local IP address is: $LOCAL_IP${RC}"
if isServiceActive "$SSH_SERVICE"; then # Check if SSH is running
if systemctl is-active --quiet "$SSH_SERVICE"; then
printf "%b\n" "${GREEN}SSH is up and running.${RC}" printf "%b\n" "${GREEN}SSH is up and running.${RC}"
else else
printf "%b\n" "${RED}Failed to start SSH.${RC}" printf "%b\n" "${RED}Failed to start SSH.${RC}"
@ -133,11 +130,12 @@ setup_samba() {
EOL EOL
fi fi
for service in smb nmb; do # Enable and start Samba services
startAndEnableService "$service" "$ESCALATION_TOOL" systemctl enable smb nmb
done "$ESCALATION_TOOL" systemctl start smb nmb
if isServiceActive smb && isServiceActive nmb; then # Check if Samba is running
if systemctl is-active --quiet smb && systemctl is-active --quiet nmb; then
printf "%b\n" "${GREEN}Samba is up and running.${RC}" printf "%b\n" "${GREEN}Samba is up and running.${RC}"
printf "%b\n" "${YELLOW}Samba share available at: $SHARED_DIR${RC}" printf "%b\n" "${YELLOW}Samba share available at: $SHARED_DIR${RC}"
else else

View File

@ -76,21 +76,6 @@ name = "Set Resolution"
description = "This script is designed to change the resolution of monitors connected to your system" description = "This script is designed to change the resolution of monitors connected to your system"
script = "monitor-control/set_resolutions.sh" script = "monitor-control/set_resolutions.sh"
[[data]]
name = "Printers"
[[data.entries]]
name = "CUPS"
script = "printers/install-cups.sh"
description = "This script will install the CUPS system, required for most printer drivers on Linux."
task_list = "I"
[[data.entries]]
name = "Epson printer drivers"
script = "printers/install-epson-printer-drivers.sh"
description = "This script will install the Epson printer drivers."
task_list = "I"
[[data]] [[data]]
name = "User Account Manager" name = "User Account Manager"
multi_select = false multi_select = false

View File

@ -12,11 +12,8 @@ install_timeshift() {
pacman) pacman)
"$ESCALATION_TOOL" "${PACKAGER}" -S --noconfirm timeshift "$ESCALATION_TOOL" "${PACKAGER}" -S --noconfirm timeshift
;; ;;
dnf|zypper|apt-get|nala)
"$ESCALATION_TOOL" "${PACKAGER}" install -y timeshift
;;
*) *)
printf "%b\n" "${RED}Unsupported package manager.${RC}" "$ESCALATION_TOOL" "${PACKAGER}" install -y timeshift
;; ;;
esac esac
else else

View File

@ -13,9 +13,6 @@ setup_xrandr() {
apt-get|nala) apt-get|nala)
"$ESCALATION_TOOL" "$PACKAGER" install -y x11-xserver-utils "$ESCALATION_TOOL" "$PACKAGER" install -y x11-xserver-utils
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add xrandr
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y xorg-x11-server-utils "$ESCALATION_TOOL" "$PACKAGER" install -y xorg-x11-server-utils
;; ;;

View File

@ -1,7 +1,6 @@
#!/bin/sh -e #!/bin/sh -e
. ../common-script.sh . ../common-script.sh
. ../common-service-script.sh
# Function to check if NetworkManager is installed # Function to check if NetworkManager is installed
setupNetworkManager() { setupNetworkManager() {
@ -14,9 +13,6 @@ setupNetworkManager() {
dnf) dnf)
"$ESCALATION_TOOL" "$PACKAGER" install -y NetworkManager-1 "$ESCALATION_TOOL" "$PACKAGER" install -y NetworkManager-1
;; ;;
apk)
"$ESCALATION_TOOL" "$PACKAGER" add networkmanager-wifi iwd
;;
*) *)
"$ESCALATION_TOOL" "$PACKAGER" install -y network-manager "$ESCALATION_TOOL" "$PACKAGER" install -y network-manager
;; ;;
@ -26,12 +22,14 @@ setupNetworkManager() {
fi fi
# Check if NetworkManager service is running # Check if NetworkManager service is running
if ! isServiceActive NetworkManager; then if ! systemctl is-active --quiet NetworkManager; then
printf "%b\n" "${YELLOW}NetworkManager service is not running. Starting it now...${RC}" printf "%b\n" "${YELLOW}NetworkManager service is not running. Starting it now...${RC}"
startService NetworkManager "$ESCALATION_TOOL" systemctl start NetworkManager
else
if systemctl is-active --quiet NetworkManager; then
printf "%b\n" "${GREEN}NetworkManager service started successfully.${RC}" printf "%b\n" "${GREEN}NetworkManager service started successfully.${RC}"
fi fi
fi
} }
# Function to display the main menu # Function to display the main menu

View File

@ -1,28 +0,0 @@
# Roadmap
## Vision
- To simplify linux tasks for all users for all distributions; Easily, efficiently, and effortlessly.
## Goals
- [ ] Focus on tasks that take time in Linux and automate them. (Example: Removing a user, adding a user, etc. - but mostly BASH scripts with POSIX compliance.)
- [x] Remove Binary linutil from being tracked in git and make it a github action.
- [ ] Document every function and feature of linutil. (Preview panel description addition)
- [x] Create a discord server for linutil and invite the community.
- [x] Power Optimizations for Laptops
## Milestones
### Q4 2024
- [x] Finish the foundation of the project's CLI
- [x] Implement CLI arguments and configuration support
- [x] Add an option for logging script executions
### Q1 2025
- [ ] GUI Brainstorming and Planning
- [ ] Basic GUI Implementation
### Q2 2025
- [ ] Full GUI Implementation
## Community Feedback
- Encourage community input and suggestions for future development.

View File

@ -1,143 +0,0 @@
<!-- THIS FILE IS GENERATED BY cargo xtask docgen -->
# Walkthrough
## Applications Setup
### Communication Apps
- **Discord**: Discord is a versatile communication platform for gamers and communities, offering voice, video, and text chat features.
- **Jitsi**: Jitsi Meet is an open-source video conferencing tool that allows users to host and join secure meetings directly from their web browsers without the need for downloads.
- **Signal**: Signal is a privacy-focused messaging app that provides end-to-end encryption for secure text, voice, and video communication.
- **Slack**: Slack is a collaboration platform designed for team communication, featuring channels, direct messaging, file sharing, and integrations with various productivity tools.
- **Telegram**: Telegram is a cloud-based messaging app known for its speed and security, offering features like group chats, channels, and end-to-end encrypted calls.
- **Thunderbird**: Thunderbird is a free, open-source email client that offers powerful features like customizable email management, a built-in calendar, and extensive add-ons for enhanced functionality.
- **Zoom**: Zoom is a widely-used video conferencing platform that allows users to host virtual meetings, webinars, and online collaboration with features like screen sharing and recording.
### Developer Tools
- **Github Desktop**: GitHub Desktop is a user-friendly application that simplifies the process of managing Git repositories and interacting with GitHub, providing a graphical interface for tasks like committing, branching, and syncing changes.
- **JetBrains Toolbox**: JetBrains Toolbox is a collection of tools and an app that help developers work with JetBrains products.
- **Meld**: Meld is a visual diff and merge tool that helps compare files, directories, and version-controlled projects.
- **Neovim**: Neovim is a refactor, and sometimes redactor, in the tradition of Vim.
It is not a rewrite but a continuation and extension of Vim.
This command configures neovim from CTT's neovim configuration.
https://github.com/ChrisTitusTech/neovim
- **Ngrok**: Ngrok is a tool that creates secure, temporary tunnels to expose local servers to the internet for testing and development.
- **Sublime Text**: Sublime Text is a fast, lightweight, and customizable text editor known for its simplicity, powerful features, and wide range of plugins for various programming languages.
- **VS Code**: Visual Studio Code (VS Code) is a lightweight, open-source code editor with built-in support for debugging, version control, and extensions for various programming languages and frameworks.
- **VS Codium**: VSCodium is a free, open-source version of Visual Studio Code (VS Code) that removes Microsoft-specific telemetry and branding.
### Office Suites
### PDF Suites
### Web Browsers
- **Brave**: Brave is a free and open-source web browser developed by Brave Software, Inc. based on the Chromium web browser.
- **Chromium**: Chromium is an open-source web browser project started by Google, to provide the source code for the proprietary Google Chrome browser.
- **Google Chrome**: Google Chrome is a fast, secure, and free web browser, built for the modern web.
- **LibreWolf**: LibreWolf is a fork of Firefox, focused on privacy, security, and freedom.
- **Lynx**: Lynx is a highly configurable text-based web browser for use on cursor-addressable character cell terminals.
- **Mozilla Firefox**: Mozilla Firefox is a free and open-source web browser developed by the Mozilla Foundation.
- **Thorium**: Thorium is a Chromium-based browser focused on privacy and performance.
- **Vivaldi**: Vivaldi is a freeware, cross-platform web browser developed by Vivaldi Technologies.
- **Tor Browser**: Tor Browser is a free and open-source firefox-based web browser designed for anonymity and censorship circumvention.
- **waterfox**: Waterfox is the privacy-focused web browser engineered to give you speed, control, and peace of mind on the internet.
- **Alacritty**: Alacritty is a modern terminal emulator that comes with sensible defaults, but allows for extensive configuration. By integrating with other applications, rather than reimplementing their functionality, it manages to provide a flexible set of features with high performance. The supported platforms currently consist of BSD, Linux, macOS and Windows. This command installs and configures alacritty terminal emulator.
- **Android Debloater**: Universal Android Debloater (UAD) is a tool designed to help users remove bloatware and unnecessary pre-installed applications from Android devices, enhancing performance and user experience.
- **Bash Prompt**: The .bashrc file is a script that runs every time a new terminal session is started in Unix-like operating systems. It is used to configure the shell session, set up aliases, define functions, and more, making the terminal easier to use and more powerful. This command configures the key sections and functionalities defined in the .bashrc file from CTT's mybash repository. https://github.com/ChrisTitusTech/mybash
- **Bottles**: Bottles allows Windows software, like applications and games, to run on Linux. Bottles also provides tools to categorize, organize and optimize your applications.
- **Docker**: Docker is an open platform that uses OS-level virtualization to deliver software in packages called containers.
- **Podman**: Podman is a daemon-less open platform that uses OS-level virtualization to deliver software in packages called containers.
- **Podman-compose**: Podman Compose is a tool for defining and running multi-container applications using Podman.
- **DWM-Titus**: DWM is a dynamic window manager for X.
It manages windows in tiled, monocle and floating layouts.
All of the layouts can be applied dynamically, optimising the environment for the application in use and the task performed.
This command installs and configures DWM and a desktop manager.
The list of patches applied can be found in CTT's DWM repository
https://github.com/ChrisTitusTech/dwm-titus
- **Fastfetch**: Fastfetch is a neofetch-like tool for fetching system information and displaying it prettily. It is written mainly in C, with performance and customizability in mind. This command installs fastfetch and configures from CTT's mybash repository. https://github.com/ChrisTitusTech/mybash
- **Flatpak / Flathub**: Flatpak is a universal application sandbox for Linux that uses isolated packages from Flathub to prevent conflicts and system alterations, while alleviating dependency concerns. This command installs Flatpak and adds the Flathub repository
- **Grub Theme**: Installs ChrisTitusTech's Top 5 Bootloader Themes script to allow for easy customization of GRUB.
- **Kitty**: kitty is a free and open-source GPU-accelerated terminal emulator for Linux, macOS, and some BSD distributions, focused on performance and features. kitty is written in a mix of C and Python programming languages. This command installs and configures kitty.
- **Linutil Installer**: Installs a distro-specific Linutil package locally.
- **Linutil Updater**: Updates your local Linutil crate installation.
- **Rofi**: Rofi is a window switcher, run dialog, ssh-launcher and dmenu replacement that started as a clone of simpleswitcher, written by Sean Pringle and later expanded by Dave Davenport. This command installs and configures rofi with configuration from CTT's DWM repo. https://github.com/ChrisTitusTech/dwm-titus
- **Waydroid**: Waydroid is an emulator that allows you to run Android apps and games on Linux.
- **ZSH Prompt**: The Z shell is a Unix shell that can be used as an interactive login shell and as a command interpreter for shell scripting. Zsh is an extended Bourne shell with many improvements, including some features of Bash, ksh, and tcsh. This command installs ZSH prompt and provides basic configuration.
## Gaming
### Diablo II Resurrected
- **Loot Filter**: This is a loot filter for Diablo II Resurrected. It's designed to be a simple, clean, and easy to read loot filter that highlights the most important items. Works on battle.net and single player. No frills, no config, just highlights high runes and other valuable items. For more information visit: https://github.com/ChrisTitusTech/d2r-loot-filter
## Security
- **Firewall Baselines (CTT)**: Developed to ease iptables firewall configuration, UFW provides a user friendly way to create an IPv4 or IPv6 host-based firewall. This command installs UFW and configures UFW based on CTT's recommended rules. For more information visit: https://christitus.com/linux-security-mistakes
## System Setup
### Arch Linux
- **Arch Server Setup**: This command installs a minimal arch server setup under 5 minutes.
- **Linux Neptune for SteamDeck**: Valve's fork of Linux Kernel for the SteamDeck
- **Nvidia Drivers && Hardware Acceleration**: This script installs and configures nvidia drivers with Hardware Acceleration.
- **Paru AUR Helper**: Paru is your standard pacman wrapping AUR helper with lots of features and minimal interaction. To know more about AUR helpers visit: https://wiki.archlinux.org/title/AUR_helpers
- **Virtualization**: QEMU, Libvirt, Virt-Manager installation and configuration.
- **Yay AUR Helper**: Yet Another Yogurt - An AUR Helper Written in Go. To know more about AUR helpers visit: https://wiki.archlinux.org/title/AUR_helpers
### Fedora
- **Configure DNF**: Optimizes DNF for parallel downloads
- **Multimedia Codecs**: This script is designed to install multimedia codecs, and to ensure RPM Fusion repositories are installed.
- **Nvidia Proprietary Drivers**: This script is designed to download the proprietary NVIDIA drivers in Fedora.
- **RPM Fusion**: RPM Fusion provides software that the Fedora Project or Red Hat doesn't want to ship. That software is provided as precompiled RPMs for all current Fedora versions and current Red Hat Enterprise Linux or clones versions; you can use the RPM Fusion repositories with tools like yum and PackageKit. For more information visit: https://rpmfusion.org/
- **Upgrade to a New Fedora Release**: Upgrades system to the next Fedora release
- **Virtualization**: Enables Virtualization through dnf
- **Btrfs Assistant, Snapper Config, grub-btrfs**: Installs Btrfs Assistant, Snapper, dnf snapper plugin and takes the first root(/) and /home snapshots. Enables snapper-timeline and snapper-cleanup services. Installs Grub-Btrfs. Notice: To perform a system recovery via grub-btrfs, perform a restore operation with Btrfs Assistant GUI after booting into the snapshot. Notice: If you used the default Fedora disk partitioning during OS installation, the /boot configured as an separate EXT4 partition. Therefore, it cannot be included in root snapshots. Backup separately.
- **Build Prerequisites**: This script is designed to handle the installation of various software dependencies across different Linux distributions
- **Full System Cleanup**: This script is designed to remove unnecessary packages, clean old cache files, remove temporary files, and to empty the trash.
- **Full System Update**: This command updates your system to the latest packages available for your distro
- **Gaming Dependencies**: This script is designed to handle the installation of gaming dependencies across different Linux distributions
- **Global Theme**: This script is designed to handle the installation and configuration of global theming
- **Remove Snaps**: This script is designed to remove snap
- **TTY Fonts**: This Script will set the default TTY font to Terminus size 32 Bold
## Utilities
### Monitor Control
- **Auto Detect Displays**: This script is designed to detect and apply recommended configuration for monitors connected with your system
- **Change Orientation**: This script is designed to change the orientation of monitors in your system
- **Disable Monitor**: This script is designed to disable a monitor in your system
- **Duplicate Displays**: This script is designed to duplicate display among multi-monitor setup in your system
- **Enable Monitor**: This script is designed to enable a monitor in your system
- **Extend Displays**: This script is designed to extend display among multi-monitor setup in your system
- **Manage Arrangement**: This script is designed to arrange monitors in multi-monitor setup in your system
- **Reset Scaling**: This script is designed to reset scaling of a monitor in your system
- **Scale Monitors**: This script is designed to change the scaling of monitors in your system
- **Set Brightness**: This script is designed to change the Brightness of monitors connected to your system
- **Set Primary Monitor**: This script is designed to set a Primary monitor in your system
- **Set Resolution**: This script is designed to change the resolution of monitors connected to your system
### Printers
- **CUPS**: This script will install the CUPS system, required for most printer drivers on Linux.
- **Epson printer drivers**: This script will install the Epson printer drivers.
### User Account Manager
- **Auto Mount Drive**: This utility is designed to help with automating the process of mounting a drive on to your system.
- **Bluetooth Manager**: This utility is designed to manage bluetooth in your system
- **Numlock on Startup**: This utility is designed to enable Num Lock at boot, rather than within desktop environments like KDE or GNOME
- **Ollama**: This utility is designed to manage ollama in your system
- **Service Manager**: This utility is designed to manage services in your system
- **WiFi Manager**: This utility is designed to manage wifi in your system

View File

@ -22,10 +22,6 @@ curl -fsSL https://christitus.com/linux | sh
curl -fsSL https://christitus.com/linuxdev | sh curl -fsSL https://christitus.com/linuxdev | sh
.SH OPTIONS .SH OPTIONS
.TP
\fB\-c\fR, \fB\-\-config\fR \fI<path>\fR
Path to the configuration file.
.TP .TP
\fB\-t\fR, \fB\-\-theme\fR \fI<theme>\fR \fB\-t\fR, \fB\-\-theme\fR \fI<theme>\fR
Set the theme to use in the TUI. Set the theme to use in the TUI.
@ -36,10 +32,6 @@ Possible values:
.br .br
Defaults to \fIdefault\fR. Defaults to \fIdefault\fR.
.TP
\fB\-y\fR, \fB\-\-skip\-confirmation\fR
Skip confirmation prompt before executing commands.
.TP .TP
\fB\-\-override\-validation\fR \fB\-\-override\-validation\fR
Show all available entries, disregarding compatibility checks. (\fBUNSAFE\fR) Show all available entries, disregarding compatibility checks. (\fBUNSAFE\fR)

View File

@ -43,7 +43,7 @@ check $? "Downloading linutil"
chmod +x "$temp_file" chmod +x "$temp_file"
check $? "Making linutil executable" check $? "Making linutil executable"
"$temp_file" "$@" "$temp_file"
check $? "Executing linutil" check $? "Executing linutil"
rm -f "$temp_file" rm -f "$temp_file"

View File

@ -69,7 +69,7 @@ check $? "Downloading linutil"
chmod +x "$TMPFILE" chmod +x "$TMPFILE"
check $? "Making linutil executable" check $? "Making linutil executable"
"$TMPFILE" "$@" "$TMPFILE"
check $? "Executing linutil" check $? "Executing linutil"
rm -f "$TMPFILE" rm -f "$TMPFILE"

View File

@ -15,12 +15,12 @@ tips = ["rand"]
[dependencies] [dependencies]
clap = { version = "4.5.20", features = ["derive"] } clap = { version = "4.5.20", features = ["derive"] }
ego-tree = { workspace = true }
oneshot = "0.1.8" oneshot = "0.1.8"
portable-pty = "0.8.1" portable-pty = "0.8.1"
ratatui = "0.29.0" ratatui = "0.29.0"
tui-term = "0.2.0" tui-term = "0.2.0"
temp-dir = "0.1.14" temp-dir = "0.1.14"
time = { version = "0.3.36", features = ["local-offset", "macros", "formatting"] }
unicode-width = "0.2.0" unicode-width = "0.2.0"
rand = { version = "0.8.5", optional = true } rand = { version = "0.8.5", optional = true }
linutil_core = { path = "../core", version = "24.9.28" } linutil_core = { path = "../core", version = "24.9.28" }

View File

@ -1,5 +1,6 @@
use crate::{state::ListEntry, theme::Theme}; use crate::{state::ListEntry, theme::Theme};
use linutil_core::{ego_tree::NodeId, Tab}; use ego_tree::NodeId;
use linutil_core::Tab;
use ratatui::{ use ratatui::{
crossterm::event::{KeyCode, KeyEvent, KeyModifiers}, crossterm::event::{KeyCode, KeyEvent, KeyModifiers},
layout::{Position, Rect}, layout::{Position, Rect},

View File

@ -170,7 +170,7 @@ impl FloatingText {
fn scroll_down(&mut self) { fn scroll_down(&mut self) {
let visible_lines = self.frame_height.saturating_sub(2); let visible_lines = self.frame_height.saturating_sub(2);
if self.v_scroll + visible_lines < self.wrapped_lines.len() { if self.v_scroll + visible_lines < self.src.len() {
self.v_scroll += 1; self.v_scroll += 1;
} }
} }

View File

@ -71,8 +71,8 @@ impl Shortcut {
} }
fn to_spans(&self) -> Vec<Span<'static>> { fn to_spans(&self) -> Vec<Span<'static>> {
let description = Span::styled(self.desc, Style::default().italic()); let mut ret: Vec<_> = self
self.key_sequences .key_sequences
.iter() .iter()
.flat_map(|seq| { .flat_map(|seq| {
[ [
@ -81,7 +81,8 @@ impl Shortcut {
Span::default().content("] "), Span::default().content("] "),
] ]
}) })
.chain(std::iter::once(description)) .collect();
.collect() ret.push(Span::styled(self.desc, Style::default().italic()));
ret
} }
} }

View File

@ -9,7 +9,6 @@ mod theme;
use std::{ use std::{
io::{self, stdout}, io::{self, stdout},
path::PathBuf,
time::Duration, time::Duration,
}; };
@ -31,18 +30,10 @@ use state::AppState;
// Linux utility toolbox // Linux utility toolbox
#[derive(Debug, Parser)] #[derive(Debug, Parser)]
struct Args { struct Args {
#[arg(short, long, help = "Path to the configuration file")]
config: Option<PathBuf>,
#[arg(short, long, value_enum)] #[arg(short, long, value_enum)]
#[arg(default_value_t = Theme::Default)] #[arg(default_value_t = Theme::Default)]
#[arg(help = "Set the theme to use in the application")] #[arg(help = "Set the theme to use in the application")]
theme: Theme, theme: Theme,
#[arg(
short = 'y',
long,
help = "Skip confirmation prompt before executing commands"
)]
skip_confirmation: bool,
#[arg(long, default_value_t = false)] #[arg(long, default_value_t = false)]
#[clap(help = "Show all available options, disregarding compatibility checks (UNSAFE)")] #[clap(help = "Show all available options, disregarding compatibility checks (UNSAFE)")]
override_validation: bool, override_validation: bool,
@ -54,13 +45,7 @@ struct Args {
fn main() -> io::Result<()> { fn main() -> io::Result<()> {
let args = Args::parse(); let args = Args::parse();
let mut state = AppState::new( let mut state = AppState::new(args.theme, args.override_validation, args.size_bypass);
args.config,
args.theme,
args.override_validation,
args.size_bypass,
args.skip_confirmation,
);
stdout().execute(EnterAlternateScreen)?; stdout().execute(EnterAlternateScreen)?;
enable_raw_mode()?; enable_raw_mode()?;

View File

@ -17,11 +17,11 @@ use std::{
sync::{Arc, Mutex}, sync::{Arc, Mutex},
thread::JoinHandle, thread::JoinHandle,
}; };
use time::{macros::format_description, OffsetDateTime};
use tui_term::{ use tui_term::{
vt100::{self, Screen}, vt100::{self, Screen},
widget::PseudoTerminal, widget::PseudoTerminal,
}; };
pub struct RunningCommand { pub struct RunningCommand {
/// A buffer to save all the command output (accumulates, until the command exits) /// A buffer to save all the command output (accumulates, until the command exits)
buffer: Arc<Mutex<Vec<u8>>>, buffer: Arc<Mutex<Vec<u8>>>,
@ -37,7 +37,6 @@ pub struct RunningCommand {
writer: Box<dyn Write + Send>, writer: Box<dyn Write + Send>,
/// Only set after the process has ended /// Only set after the process has ended
status: Option<ExitStatus>, status: Option<ExitStatus>,
log_path: Option<String>,
scroll_offset: usize, scroll_offset: usize,
} }
@ -80,20 +79,10 @@ impl FloatContent for RunningCommand {
.style(Style::default()), .style(Style::default()),
); );
let mut block = Block::default() Block::default()
.borders(Borders::ALL) .borders(Borders::ALL)
.border_set(ratatui::symbols::border::ROUNDED) .border_set(ratatui::symbols::border::ROUNDED)
.title_top(title_line.centered()); .title_top(title_line.centered())
if let Some(log_path) = &self.log_path {
block =
block.title_bottom(Line::from(format!(" Log saved: {} ", log_path)).centered());
} else {
block =
block.title_bottom(Line::from(" Press 'l' to save command log ").centered());
}
block
}; };
// Process the buffer and create the pseudo-terminal widget // Process the buffer and create the pseudo-terminal widget
@ -122,11 +111,6 @@ impl FloatContent for RunningCommand {
KeyCode::PageDown => { KeyCode::PageDown => {
self.scroll_offset = self.scroll_offset.saturating_sub(10); self.scroll_offset = self.scroll_offset.saturating_sub(10);
} }
KeyCode::Char('l') if self.is_finished() => {
if let Ok(log_path) = self.save_log() {
self.log_path = Some(log_path);
}
}
// Pass other key events to the terminal // Pass other key events to the terminal
_ => self.handle_passthrough_key_event(key), _ => self.handle_passthrough_key_event(key),
} }
@ -150,7 +134,6 @@ impl FloatContent for RunningCommand {
Shortcut::new("Close window", ["Enter", "q"]), Shortcut::new("Close window", ["Enter", "q"]),
Shortcut::new("Scroll up", ["Page up"]), Shortcut::new("Scroll up", ["Page up"]),
Shortcut::new("Scroll down", ["Page down"]), Shortcut::new("Scroll down", ["Page down"]),
Shortcut::new("Save log", ["l"]),
]), ]),
) )
} else { } else {
@ -254,7 +237,6 @@ impl RunningCommand {
pty_master: pair.master, pty_master: pair.master,
writer, writer,
status: None, status: None,
log_path: None,
scroll_offset: 0, scroll_offset: 0,
} }
} }
@ -273,7 +255,7 @@ impl RunningCommand {
// Process the buffer with a parser with the current screen size // Process the buffer with a parser with the current screen size
// We don't actually need to create a new parser every time, but it is so much easier this // We don't actually need to create a new parser every time, but it is so much easier this
// way, and doesn't cost that much // way, and doesn't cost that much
let mut parser = vt100::Parser::new(size.height, size.width, 1000); let mut parser = vt100::Parser::new(size.height, size.width, 200);
let mutex = self.buffer.lock(); let mutex = self.buffer.lock();
let buffer = mutex.as_ref().unwrap(); let buffer = mutex.as_ref().unwrap();
parser.process(buffer); parser.process(buffer);
@ -302,24 +284,6 @@ impl RunningCommand {
} }
} }
fn save_log(&self) -> std::io::Result<String> {
let mut log_path = std::env::temp_dir();
let date_format = format_description!("[year]-[month]-[day]-[hour]-[minute]-[second]");
log_path.push(format!(
"linutil_log_{}.log",
OffsetDateTime::now_local()
.unwrap_or(OffsetDateTime::now_utc())
.format(&date_format)
.unwrap()
));
let mut file = std::fs::File::create(&log_path)?;
let buffer = self.buffer.lock().unwrap();
file.write_all(&buffer)?;
Ok(log_path.to_string_lossy().into_owned())
}
/// Convert the KeyEvent to pty key codes, and send them to the virtual terminal /// Convert the KeyEvent to pty key codes, and send them to the virtual terminal
fn handle_passthrough_key_event(&mut self, key: &KeyEvent) { fn handle_passthrough_key_event(&mut self, key: &KeyEvent) {
let input_bytes = match key.code { let input_bytes = match key.code {

View File

@ -7,8 +7,8 @@ use crate::{
running_command::RunningCommand, running_command::RunningCommand,
theme::Theme, theme::Theme,
}; };
use ego_tree::NodeId;
use linutil_core::{ego_tree::NodeId, Config, ListNode, TabList}; use linutil_core::{ListNode, TabList};
#[cfg(feature = "tips")] #[cfg(feature = "tips")]
use rand::Rng; use rand::Rng;
use ratatui::{ use ratatui::{
@ -19,7 +19,6 @@ use ratatui::{
widgets::{Block, Borders, List, ListState, Paragraph}, widgets::{Block, Borders, List, ListState, Paragraph},
Frame, Frame,
}; };
use std::path::PathBuf;
use std::rc::Rc; use std::rc::Rc;
const MIN_WIDTH: u16 = 100; const MIN_WIDTH: u16 = 100;
@ -62,7 +61,6 @@ pub struct AppState {
#[cfg(feature = "tips")] #[cfg(feature = "tips")]
tip: String, tip: String,
size_bypass: bool, size_bypass: bool,
skip_confirmation: bool,
} }
pub enum Focus { pub enum Focus {
@ -87,18 +85,10 @@ enum SelectedItem {
} }
impl AppState { impl AppState {
pub fn new( pub fn new(theme: Theme, override_validation: bool, size_bypass: bool) -> Self {
config_path: Option<PathBuf>,
theme: Theme,
override_validation: bool,
size_bypass: bool,
skip_confirmation: bool,
) -> Self {
let tabs = linutil_core::get_tabs(!override_validation); let tabs = linutil_core::get_tabs(!override_validation);
let root_id = tabs[0].tree.root().id(); let root_id = tabs[0].tree.root().id();
let auto_execute_commands = config_path.map(|path| Config::from_file(&path).auto_execute);
let mut state = Self { let mut state = Self {
theme, theme,
focus: Focus::List, focus: Focus::List,
@ -113,35 +103,12 @@ impl AppState {
#[cfg(feature = "tips")] #[cfg(feature = "tips")]
tip: get_random_tip(), tip: get_random_tip(),
size_bypass, size_bypass,
skip_confirmation,
}; };
state.update_items(); state.update_items();
if let Some(auto_execute_commands) = auto_execute_commands {
state.handle_initial_auto_execute(&auto_execute_commands);
}
state state
} }
fn handle_initial_auto_execute(&mut self, auto_execute_commands: &[String]) {
self.selected_commands = auto_execute_commands
.iter()
.filter_map(|name| self.tabs.iter().find_map(|tab| tab.find_command(name)))
.collect();
if !self.selected_commands.is_empty() {
let cmd_names: Vec<_> = self
.selected_commands
.iter()
.map(|node| node.name.as_str())
.collect();
let prompt = ConfirmPrompt::new(&cmd_names);
self.focus = Focus::ConfirmationPrompt(Float::new(Box::new(prompt), 40, 40));
}
}
fn get_list_item_shortcut(&self) -> Box<[Shortcut]> { fn get_list_item_shortcut(&self) -> Box<[Shortcut]> {
if self.selected_item_is_dir() { if self.selected_item_is_dir() {
Box::new([Shortcut::new("Go to selected dir", ["l", "Right", "Enter"])]) Box::new([Shortcut::new("Go to selected dir", ["l", "Right", "Enter"])])
@ -789,9 +756,6 @@ impl AppState {
} }
} }
if self.skip_confirmation {
self.handle_confirm_command();
} else {
let cmd_names = self let cmd_names = self
.selected_commands .selected_commands
.iter() .iter()
@ -801,7 +765,6 @@ impl AppState {
let prompt = ConfirmPrompt::new(&cmd_names[..]); let prompt = ConfirmPrompt::new(&cmd_names[..]);
self.focus = Focus::ConfirmationPrompt(Float::new(Box::new(prompt), 40, 40)); self.focus = Focus::ConfirmationPrompt(Float::new(Box::new(prompt), 40, 40));
} }
}
SelectedItem::None => {} SelectedItem::None => {}
} }
} }